// C/C++ File
// AUTHOR:   foton
// FILE:     main.c
// ROLE:     to rule them all
// CREATED:  2017-01-30 21:51:28
// MODIFIED: 2017-03-09 20:51:10

#include "fdf.h"
#include <stdio.h>


int     key_hook(int keycode, void *m)
{
    printf("%d\n", keycode);
	  if (keycode == 53 || keycode == 65307)
		  quit(m);
//    if (keycode == 123)
//        left(mlx);
//    if (keycode == 126)
//        up(mlx);
//    if (keycode == 125)
//        down(mlx);
    return (0);
}

t_mw	*mlx_and_win_ptr_init(int x, int y)
{
	t_mw *mw;

	mw = NULL;
	if ((mw = malloc(sizeof(t_mw))))
	{
		mw->mlx = mlx_init();
		mw->win = mlx_new_window(mw->mlx, x, y, "FDF");
	}
	return (mw);
}

t_FDF	*FDF_init(char *path)
{
	t_FDF	*FDF;

	FDF = NULL;
	if ((FDF = malloc(sizeof(t_FDF))))
	{
		FDF->w_heigth = HEIGHT;
		FDF->w_width = WIDTH;
		FDF->mw = mlx_and_win_ptr_init(WIDTH, HEIGHT);
		FDF->map = map_init(path);
		pnt_init(FDF->map);
	}
	return (FDF);
}

int		main(int argc, char **argv)
{
	t_FDF	*FDF;
	void 	*image;
	char 	*data;
	int 	i;
	int 	bpp;
	int 	endian;
	int 	j;
	int 	line;

	if (argc != 2)
		return (0);
	FDF = FDF_init(argv[1]);
	i = 0;
	bpp = 4;
	endian = 1;
	image = mlx_new_image(FDF->mw->mlx, FDF->w_heigth, FDF->w_heigth);
	data = mlx_get_data_addr(image, &bpp, &line, &endian);
	while (i < FDF->w_heigth)
	{
		j = 0;
		while (j < FDF->w_width)
		{
			*((int *)data + j + i * FDF->w_width) = mlx_get_color_value(FDF->mw->mlx, 0x4286f4);
			j++;
		}
		i++;
	}
	mlx_put_image_to_window(FDF->mw->mlx, FDF->mw->win, image, 0, 0);
	//render(FDF);
    mlx_key_hook(FDF->mw->win, key_hook, FDF);
	mlx_loop(FDF->mw->mlx);
	return (0);
}
